
/***************************************************
* By CCSC compiler
*  File Name: picp18lcd2_demo.c
*  Description: test switch, generate prime number, test led
*  For PIC-P18-LCD2 with 16F1827
*  RA4 switch
*  RB0 LED
*  RB4-7 data for LCD
*  RB3 RS
*  RB2 STB
*  COPYRIGHT 2014 MYCOMKITS.COM, owned by CNET LIMITED
*  $BEv%W%m%0%i%`$NCx:n8"$O!"@=:n<T!V%^%$%3%s%-%C%H%I%C%H%3%`1?1D!!M-8B2q<R%/%M%C%H!W$K5"B0$7$^$9!#(B
*  $BCx:n8"$rJ|4~$7$F$$$^$;$s$,!"Ev%W%m%0%i%`$r;H$C$?3X=,$NCf$G%W%m%0%i%`$r<+M3$KJQ99$7$F$*;H$$$/$@$5$$!#(B
***************************************************/
//
#include <16f1827.h>
#fuses	HS, NOWDT, MCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCPD, NOCLKOUT, NOWRT, NOIESO, NOFCMEN, PLL_SW, NOSTVREN
#use	delay(CLOCK = 20000000)
#use	rs232(BAUD = 9600, XMIT = PIN_A2, RCV = PIN_A3)
#include <math.h>

#define	Bmode 0x00			//port B all output
#define Amode 0xFB			//port A all input except A2

//#byte db = 6		//6 is port B address

//////// Port define and link LCD library
//////// Port define and link LCD library
#define DB7 PIN_B7
#define DB6 PIN_B6
#define DB5 PIN_B5
#define DB4 PIN_B4
#define RS PIN_B3		//Register Select
#define STB PIN_B2		//Strobe or Enable Signal
// lcd_lib.c is programmed by Testua Gokan.
#include <lcd_lib.c>
//////
int pre_start = 1;
//
// only for test
#separate
void test_serial()
{
	int cmnd;
	printf("\n\rPress Any Key=   ");
	cmnd=getc();
	printf("\n\rInput= ");
	putc(cmnd);
}
//
// only for test
#separate
void test_switch()
{
	if(input(PIN_A4)==0)
	{
		delay_ms(50);
		if(input(PIN_A4)==0)
		{
			if(pre_start==1)
			{
				output_toggle(PIN_B0);
				pre_start=0;
			}
		}
	}
	else pre_start=1;
}
//
// prime number
#separate
void test_prime()
{
    long i, j, k, m, n;
    k = 2;
    lcd_cmd(0xC0);
    printf("%lu ", k );
    printf(lcd_data, "%lu ", k );
    lcd_cmd(0xC0);
    printf("%lu ", k+1 );
    printf(lcd_data, "%lu ", k+1 );
    n=3;
    for( i = 5 ; i <= 65000 ; i = i+2 )
	{
        m = sqrt(i);
        for( j = 3; j <= m; j = j+2)
        {
        	if (i%j == 0) break;
        }
        if (i%j != 0)
        {
        	printf("%lu ", i );
    		lcd_cmd(0xC0);
    		printf(lcd_data, "p= %lu ", i );
    		lcd_cmd(0x80);
    		printf(lcd_data, "n= %lu ", n );
    		n++;
    		output_toggle(PIN_B0);
    		while(input(PIN_A4) == 0) {}
    		delay_ms(300);
        }
 	}
 	lcd_clear();		//clear display
}
//
//
void main()
{
	output_B(0x00);
	set_tris_a(Amode);	//all input
	set_tris_b(Bmode);	//all output
	//
	#use fast_io(A)
	#use fast_io(B)
	//
	//
	lcd_init();				//initialize LCD
	lcd_clear();		//clear display
	lcd_data("MYCOMKITS.com          ");
	delay_ms(500);
	lcd_cmd(0x80);
	lcd_data("Get prime number!          ");
	lcd_cmd(0x0C);	//blink and cursur off
	lcd_cmd(0xC0);
	lcd_data("Press Start          ");

	while(1)
	{
		if (input(PIN_A4) == 0)	// start
		{
			delay_ms(50);
			if (input(PIN_A4) == 0)
			{
				while(1)
				{
					lcd_clear();
					lcd_cmd(0x80);
					lcd_data("Get prime number!          ");
					delay_ms(1000);
					lcd_clear();
					test_prime();
					//delay_ms(1000);
				}
			}
		}
	}
}
